' The AntTweakBar GUI knows nothing about:
' the current WindowSize 
' the state of the Mouse (Position, Buttons, Wheel) nor the state of the keyboad.

' The helper sub Update will detect any Basic4GL state changes and translate it in TweakBar states.

' for eyample:
' Basic4GL MOUSE_LBUTTON must be translated to TW_MOUSE_LEFT same for MousePosition or any pressed keys.

' window
dim CurentWidth%,CurentHeight%
' mouse
dim CurentX#,CurentY#
dim CurentLButton%,CurentMButton%,CurentRButton%,CurentWheel%
' keyboard
dim CurentScan%

sub Update()
  
  if twIsInit()=false or TwGetBarCount()<1 then return : endif

  dim w%=WindowWidth(),h%=WindowHeight()
  if w%<>CurentWidth% or h%<>CurentHeight% then
    twWindowSize(w%,h%):CurentWidth%=w%:CurentHeight%=h%
  end if

  dim x#=Mouse_X(),y#=Mouse_Y()
  if x#<>CurentX# or y#<>CurentY# then
    twMouseMotion(x#,y#):CurentX#=x#:CurentY#=y#
  end if
  
  dim wheel%=Mouse_Wheel()
  if wheel%<>CurentWheel% then
    twMouseWheel(wheel%):CurentWheel%=wheel%
  end if                                
  
  dim LButton%=Mouse_Button(MOUSE_LBUTTON)
  if LButton%<>CurentLButton% then
    if CurentLButton%=0 then
      twMouseButton(TW_MOUSE_PRESSED,TW_MOUSE_LEFT)
    else
      twMouseButton(TW_MOUSE_RELEASED,TW_MOUSE_LEFT)
    end if
    CurentLButton%=LButton%
  end if
  
  dim RButton%=Mouse_Button(MOUSE_RBUTTON)
  if RButton%<>CurentRButton% then
    if CurentRButton%=0 then
      twMouseButton(TW_MOUSE_PRESSED,TW_MOUSE_RIGHT)
    else
      twMouseButton(TW_MOUSE_RELEASED,TW_MOUSE_RIGHT)
    end if
    CurentRButton%=RButton%
  end if
  
  dim MButton%=Mouse_Button(MOUSE_MBUTTON)
  if MButton%<>CurentMButton% then
    if CurentMButton%=0 then
      twMouseButton(TW_MOUSE_PRESSED,TW_MOUSE_MIDDLE)
    else
      twMouseButton(TW_MOUSE_RELEASED,TW_MOUSE_MIDDLE)
    end if
    CurentMButton%=MButton%
  end if
  
  dim key%,modifier%=TW_KMOD_NONE 
  dim scan% = InScanKey()
  CurentScan% = scan%
  while scan%        
    if scan%=8 then
      key%=TW_KEY_BACKSPACE
    elseif scan%=9 then
      key%=TW_KEY_TAB
    elseif scan%=13 then
      key%=TW_KEY_RETURN
    
    elseif scan%=16 then
      modifier%=TW_KMOD_SHIFT
    elseif scan%=17 then
      modifier%=TW_KMOD_CTRL
    elseif scan%=18 then
      modifier%=TW_KMOD_ALT

    elseif scan%=27 then
      key%=TW_KEY_ESCAPE

    elseif scan%=32 then
      key%=TW_KEY_SPACE
    elseif scan%=33 then
      key%=TW_KEY_PAGE_UP
    elseif scan%=34 then
      key%=TW_KEY_PAGE_DOWN
    elseif scan%=35 then
      key%=TW_KEY_END 
    elseif scan%=36 then
      key%=TW_KEY_HOME
    elseif scan%=37 then
      key%=TW_KEY_LEFT
    elseif scan%=38 then
      key%=TW_KEY_UP
    elseif scan%=39 then
      key%=TW_KEY_RIGHT
    elseif scan%=40 then
      key%=TW_KEY_DOWN
    

    elseif scan%=45 then
      key%=TW_KEY_INSERT
    elseif scan%=46 then
      key%=TW_KEY_DELETE   

    elseif scan%>47 and scan%<58 then
      key%=scan% ' 0-9

    elseif scan%>64 and scan%<91 then
      key%=scan% ' A-Z

    elseif scan%>90 and scan%<94 then
      modifier%=TW_KMOD_META
    
    elseif scan%>95 and scan%<112 then
      key%=scan% ' number block

    elseif scan%>111 and scan%<124 then
      ' F1 - F12
      key%=TW_KEY_F1 + (scan%-111)
    elseif scan%=-66 then
      key%=asc(".")
    elseif scan%=-68 then
      key%=asc(",")
    end if
    
    if key% then
      TwKeyPressed(key%,modifier%)
      modifier% = TW_KMOD_NONE 
    end if

    scan%=InScanKey()
  wend
end sub
